/*
 * auth.c - Authentication and Accounting Configuration
 *
 * $Id: auth.c,v 1.8 2004/05/13 11:28:11 tommy Exp $
 */

#include "aconfig.h"
#include "nntpd.h"
#include "memory.h"
#include "aprotos.h"

/* define this if you don't want shared libs to be closed on exit
 * this can cause sig[segv|ill]'s on exit */
#undef DONT_CLOSE_LIBS
                                                                                                                         
AUTH *auths;
void *auth_handler;
void *acct_handler;

PROTO char* (*dl_check_auth)(CLIENT *, CONFIG *, char *);
PROTO void (*dl_acct_entry)(CLIENT *, CONFIG *, char *);

/*
 * Loadable Module Operations
 */

PROTO int load_auth_module(void) {
    char l[512];
    sprintf(l, "%s/%s.%s", cfg.ModulePath, client->auth->auth->lib, VERSION);

    auth_handler = dlopen(l, RTLD_LAZY);
    if ( ! auth_handler ) {
        syslog(LOG_ERR,"cant load auth_handler module %s", dlerror());
        return -1;
    }
                                                                                                                         
    dl_check_auth = dlsym(auth_handler,"check_auth");
    return 0;
}
                                                                                                                         
PROTO int load_acct_module(void) {
    char l[512];
    sprintf(l, "%s/%s.%s", cfg.ModulePath, client->auth->acct->lib, VERSION);

    acct_handler = dlopen(l, RTLD_LAZY);
    if ( ! acct_handler ) {
        syslog(LOG_ERR,"cant load acct_handler module %s", dlerror());
        return -1;
    }
                                                                                                                         
    dl_acct_entry = dlsym(acct_handler,"acct_entry");
    return 0;
}

PROTO int unload_auth_module(void) {
#ifndef DONT_CLOSE_LIBS
    dlclose(auth_handler);
#endif
    return 0;
}

PROTO int unload_acct_module(void) {
#ifndef DONT_CLOSE_LIBS
    dlclose(acct_handler);
#endif
    return 0;
}

